//
//  main.swift
//  Predicates
//
//  Created by Holger Hinzberg on 16.02.16.
//  Copyright © 2016 Holger Hinzberg. All rights reserved.
//

import Foundation

var truckArray = [Truck]()

var truck = Truck()
truck.make = "Manyroads"
truck.color = "Blau"
truck.wheels = 4
truckArray.append(truck)

truck = Truck()
truck.make = "Heavylift"
truck.color = "Silber"
truck.wheels = 4
truckArray.append(truck)

truck = Truck()
truck.make = "Manyroads"
truck.color = "Schwarz"
truck.wheels = 6
truckArray.append(truck)

truck = Truck()
truck.make = "Drivealot"
truck.color = "Rot"
truck.wheels = 6
truckArray.append(truck)

truck = Truck()
truck.make = "Cargoking"
truck.color = "Rot"
truck.wheels = 6
truckArray.append(truck)

// Ein Predicate für die Marke definieren
//let nameFilter = NSPredicate(format: "make == 'Manyroads'")

// Alle Hersteller, die mit einem D oder d beginnen
// let nameFilter = NSPredicate(format: "make BEGINSWITH [cd] %@","d")

// Hersteller mit einem Y oder mit roter Farbe
//let nameFilter = NSPredicate(format:"make CONTAINS [c] %@ OR color CONTAINS [c] %@","y", "rot")

let nameFilter = NSPredicate(format:"wheels >= 6  && make == 'Manyroads'")

// Maximale Anzahl von Reifen
let maxWheels = 4
// Maximale Anzahl von Zeichen
let maxCharacters = 3

var predicate =  NSPredicate
    {
        (evaluatedObject, bindings) in
        
        if let truck = evaluatedObject as? Truck
        {
            if truck.color?.characters.count == maxCharacters ||
                truck.wheels <= maxWheels
            {
                return true
            }
        }
        return false
}

// Den Filter anwenden und eine neues Array füllen
let filteredTrucks = truckArray.filter {predicate.evaluateWithObject($0)}

// Das gefilterte Ergebnis ausgeben
for singleTruck in filteredTrucks
{
    print("\(singleTruck.make!) \(singleTruck.color!)")
}

/*
for singleTruck in truckArray
{
    if nameFilter.evaluateWithObject(singleTruck)
    {
            print(String(format: "Gesuchtes Fahrzeug: %@ in %@",
                singleTruck.make!, singleTruck.color! ))
    }
    else
    {
        print(String(format: "Ein anderes Fahrzeug: %@ in %@",
            singleTruck.make!, singleTruck.color!))
    }
}
*/











